/**
 * @fileoverview polyline
 * @author dengfuping_develop@163.com
 */
import { Point } from '@antv/g-base/lib/types';
import ShapeBase from './base';
declare class Polyline extends ShapeBase {
    type: string;
    canFill: boolean;
    canStroke: boolean;
    onAttrChange(name: string, value: any, originValue: any): void;
    _resetCache(): void;
    createPath(context: any, targetAttrs: any): void;
    /**
     * Get length of polyline
     * @return {number} length
     */
    getTotalLength(): any;
    /**
     * Get point according to ratio
     * @param {number} ratio
     * @return {Point} point
     */
    getPoint(ratio: number): Point;
    _setTcache(): void;
}
export default Polyline;
